
<!DOCTYPE html>
<html lang="en">

<head>
    <title>JR4.30 Danh sách học viên</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container mt-4">
        <h2 style="text-align: center;">Danh sách học viên</h2>
        <button style="margin-bottom: 10px;" class="btn btn-success " id="btn-insert">Thêm sinh viên</button>
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>Birthday</th>
                    <th>Email</th>
                    <th>Phone</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>

    <!-- vùng modal -->

    <!-- modal thêm -->
    <div>
        <div id="add-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Thêm sinh viên</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-add-user-name">Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-add-user-name" name="Name"
                                        placeholder="Name" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-add-user-birthday">Birthday</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="date" id="input-add-user-birthday" name="Birthday"
                                        placeholder="Birthday" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-add-user-email">Email</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-add-user-email" name="Email" placeholder="Email"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-add-user-phone">Phone</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-add-user-phone" name="Phone" placeholder="Phone"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-insert-user">Thêm sinh viên</button>
                        <button class="btn btn-warning" id="btn-cancel-user" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- modal sửa -->
    <div>
        <div id="change-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết Sinh viên</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-change-user-name">Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-change-user-name" name="Name"
                                        placeholder="Name" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-change-user-birthday">Birthday</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="date" id="input-change-user-birthday" name="Birthday"
                                        placeholder="Birthday" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-change-user-email">Email</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-change-user-email" name="Email" placeholder="Email"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-change-user-phone">Phone</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-change-user-phone" name="Phone" placeholder="Phone"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-update-user">Update thông tin Sinh viên</button>
                        <button class="btn btn-warning" id="btn-cancel-user" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- modal xóa -->
    <div>
        <div id="delete-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-12">
                                    <h6>Bạn có chắn chắn muốn xóa user này không?</h6>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-delete-user">Xác nhận</button>
                        <button class="btn btn-info" id="btn-cancel-user" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>

    /*** vùng 1 ***/
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://devcamp-student-datatables.herokuapp.com/users/";

    const gDATA_COLUMN = [
        "id",
        "name",
        "birthday",
        "email",
        "phone",
        "action",
    ];
    const gID = 0;
    const gNAME = 1;
    const gBIRTHDAY = 2;
    const gEMAIL = 3;
    const gPHONE = 4;
    const gACTION = 5;

    var gDataTable = $("#user-table").DataTable({
        "columns": [
            { "data": gDATA_COLUMN[gID] },
            { "data": gDATA_COLUMN[gNAME] },
            { "data": gDATA_COLUMN[gBIRTHDAY] },
            { "data": gDATA_COLUMN[gEMAIL] },
            { "data": gDATA_COLUMN[gPHONE] },
            { "data": gDATA_COLUMN[gACTION] }
        ],
        columnDefs: [
            {
                targets: gACTION,//cột action
                defaultContent: "<button class='btn btn-primary btn-change'>Sửa</button> <button class='btn btn-danger btn-delete'>Xóa</button>"
            }
        ]
    })

    var gAllUser = "";
    var gUserID = "";
    var gUserUpdate = "";

    /*** vùng 2 ***/
    $(document).ready(function () {
        callApiGetAllUser(gAllUser);
    })

    // hàm sự kiện click nút sửa
    $("#user-table").on("click", ".btn-change", function () {
        onBtnChangeClick(this);
        $("#change-user-modal").modal("show");
    });

    // hàm sự kiện click nút xóa
    $("#user-table").on("click", ".btn-delete", function () {
        onBtnDeleteClick(this);
        $("#delete-user-modal").modal("show");
    });

    // hàm sự kiện nhấn nút thêm user
    $("#btn-insert").click(function () {
        $("#add-user-modal").modal("show");
    })

    // hàm sự kiện nhấn nút thêm người dùng
    $("#btn-insert-user").click(function () {
        var vNewUser = {
            name: "",
            birthday: "",
            email: "",
            phone: ""
        };
        // bước 1 lấy dữ liệu
        getDataNewUser(vNewUser);
        // bước 2 kiểm tra dữ liệu
        var vValiDateDataNewUser = validateDataNewUser(vNewUser);
        // bước 3 call api
        if (vValiDateDataNewUser) {
            callApiCreateNewUser(vNewUser);
            resetFormInsert();
            $("#add-user-modal").modal("hide");
            location.reload();
        }
    })

    // hàm sự kiện nhấn nút update user
    $("#btn-update-user").click(function () {
        var vUpdateUser = {
            name: "",
            birthday: "",
            email: "",
            phone: ""
        }

        // bước 1 lấy dữ liệu từ form nhập
        getDataUserUpdate(vUpdateUser);
        // bước 2 kiểm tra thông tin
        var vValiDateDataUpdateUser = valiDateDataUpdateUser(vUpdateUser);
        // bước 3 call api update thông tin user
        if (vValiDateDataUpdateUser) {
            callApiUpdateDataUser(vUpdateUser);
            callApiGetAllUser(gAllUser)
            loadDataToTable(gAllUser)
            resetFormChange();
            $("#change-user-modal").modal("hide");
            location.reload();
        }

    })

    // hàm sự kiện nhấn nút xác nhận xóa user
    $("#btn-delete-user").click(function () {
        // bước 1 lấy thông tin (không có)
        // bước 2 kiểm tra thông tin (không có)
        // bước 3 call api xóa người dùng
        callApiDeleteUser();
        callApiGetAllUser(gAllUser)
        loadDataToTable(gAllUser)
        $("#delete-user-modal").modal("hide");
        location.reload();

    })

    /*** vùng 3 ***/
    // hàm call api lấy thông tin tất cả user
    function callApiGetAllUser(gAllUser) {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (response) {
                gAllUser = response;
                console.log(gAllUser);
                loadDataToTable(gAllUser)

            },
            error: function (response) {
                console.log(response.status)
            }
        })
    }

    // hàm load dữ liệu vào  table
    function loadDataToTable(paramUserObject) {
        "use strict"
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramUserObject);
        vTable.draw();
    }

    // hàm xử lý sự kiện nhấn nút change
    function onBtnChangeClick(paramBtnChange) {
        // lưu thông tin voucherId đang được edit vào biến toàn cục
        gUserUpdate = getUserIdFormBtn(paramBtnChange);
        console.log(gUserUpdate.id);
        // gán giá trị vào các trường input của modal update
        assignValueUserUpdate(gUserUpdate);
    }

    // hàm xử lý sự kiện nhấn nút delete
    function onBtnDeleteClick(paramBtnChange) {
        // lưu thông tin voucherId đang được edit vào biến toàn cục
        gUserUpdate = getUserIdFormBtn(paramBtnChange);
        console.log(gUserUpdate.id)

    }


    /*** vùng 4 ***/
    // hàm dựa vào button detail (edit or delete) xác định đc id voucher
    function getUserIdFormBtn(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gDataTable.row(vTableRow).data();
        return vUserRowData;
    }

    // hàm lấy thông tin người dùng mới từ form
    function getDataNewUser(paramNewUser) {
        paramNewUser.name = $("#input-add-user-name").val().trim();
        paramNewUser.birthday = $("#input-add-user-birthday").val().trim();
        paramNewUser.phone = $("#input-add-user-phone").val().trim();
        paramNewUser.email = $("#input-add-user-email").val();
    }

    // hàm kiểm tra thông tin người dùng mới
    function validateDataNewUser(paramNewUser) {
        if (paramNewUser.name == "") {
            alert("Please enter Name!");
            return false;
        }
        if (paramNewUser.birthday == "") {
            alert("Please enter Birthday!");
            return false;
        }
        if (paramNewUser.email == "") {
            alert("Please enter Email!");
            return false;
        }
        if (paramNewUser.phone === "") {
            alert("Please select Phone!");
            return false;
        }
        return true;
    }

    // hàm call api tạo thông tin người dùng mới
    function callApiCreateNewUser(paramNewUser) {
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            data: JSON.stringify(paramNewUser),
            contentType: "application/json",

            success: function (reponse) {
                alert("đã thêm sinh viên thành công")
                console.log(reponse)
            },
            error: function (reponse) {
                console.log(response.status)
            }
        })
    }

    // hàm xóa trắng thông tin form modal tạo người dùng mới
    function resetFormInsert() {
        $("#input-add-user-firstname").val("");
        $("#input-add-user-lastname").val('');
        $("#input-add-user-subject").val("");
        $("#select-add-user-country").val("none")
    }

    // hàm xóa trắng thông tin form modal sửa thông tin người dùng
    function resetFormChange() {
        $("#input-change-user-firstname").val("");
        $("#input-change-user-lastname").val("");
        $("#input-change-user-subject").val("");
        $("#select-change-user-country").val("none");
        $("#select-change-user-customertype").val("none");
        $("#select-change-user-registerstatus").val("none");
    }

    // hàm lấy thông tin update user từ form
    function getDataUserUpdate(paramUpdateUser) {
        paramUpdateUser.name = $("#input-change-user-name").val().trim();
        paramUpdateUser.birthday = $("#input-change-user-birthday").val().trim();
        paramUpdateUser.email = $("#input-change-user-email").val().trim();
        paramUpdateUser.phone = $("#input-change-user-phone").val().trim();
        console.log(paramUpdateUser)
    }

    // hàm kiểm tra thông tin update user
    function valiDateDataUpdateUser(paramUpdateUser) {
        if (paramUpdateUser.name == "") {
            alert("Please enter Name!");
            return false;
        }
        if (paramUpdateUser.birthday == "") {
            alert("Please enter Birthday!");
            return false;
        }
        if (paramUpdateUser.phone == "") {
            alert("Please enter Phone!");
            return false;
        }
        if (paramUpdateUser.email === "") {
            alert("Please select Email!");
            return false;
        }
        return true;
    }

    // hàm gán giá trị vào các trường modal update user
    function assignValueUserUpdate(paramUserUpdate) {
        $("#input-change-user-name").val(paramUserUpdate.name);
        $("#input-change-user-birthday").val(formatStringDate(paramUserUpdate.birthday));
        $("#input-change-user-email").val(paramUserUpdate.email);
        $("#input-change-user-phone").val(paramUserUpdate.phone);
    }

    // hàm call api update data user
    function callApiUpdateDataUser(paramUpdateUser) {
        $.ajax({
            url: gBASE_URL + gUserUpdate.id,
            type: "PUT",
            data: JSON.stringify(paramUpdateUser),
            contentType: "application/json",
            success: function (response) {
                alert("update user thành công!")
                console.log(response);
            },
            error: function (response) {
                console.log(response.status);
            }
        })
    }

    // hàm call api delete user
    function callApiDeleteUser() {
        $.ajax({
            url: gBASE_URL + gUserUpdate.id,
            type: "DELETE",
            async: false,
            success: function (response) {
                alert("Xóa user thành công!");
                console.log(response + "kkk");
            },
            error: function (response) {
                console.log(response.status);
            }
        })
    }

    //hàm format date từ dạng mm/dd/YYYY sang YYYY-mm-dd
    function formatStringDate(paramDate) {
        var vDateArray = paramDate.split("/");

        if(vDateArray.length > 1) {
            return vDateArray[2]+"-"+('0' + parseInt(vDateArray[0])).slice(-2)+"-"+('0' + parseInt(vDateArray[1])).slice(-2);
        } else {
            return paramDate;
        }
    }
</script>

</html>